function im = DisplayGraphOnMap(A,C,GoalDestinations,s,filename,newfigure)

if nargin == 3
    newfigure = 1;
end

global DebugInfo;

% some error checking first...

if A ~= A'
    error('Adjacency matrix must be symmetric');
end

if size(C,1) ~= size(A,1)
    error('C and A dimensions do not mathc');
end


im = imread(filename);

if newfigure == 1
    figure;
end

if numel(size(im)) == 3
    im = rgb2gray(im);
end

a = uint8(255*edge(im,'canny'));
a(a<127) = 127;
a(a>127) = 0;
a(a==127) = 255;
im = a;

imshow(im);
hold on
nvertices = size(C,1);

% draw all vertices first
for i =1:nvertices
    plot(C(i,2),C(i,1),'or');
    if DebugInfo==1
        h = text(C(i,2)+2,C(i,1),sprintf('%d',i));
        %  h = text(C(GoalDestinations(i),2)+2,C(GoalDestinations(i),1),sprintf('%d',GoalDestinations(i)));
        set(h,'FontSize',20);
        set(h,'Color',[1 0 0]);
    end
end

% then redraw destination vertices and label then
for i =1:numel(GoalDestinations)
    h=plot(C(GoalDestinations(i),2),C(GoalDestinations(i),1),'xg','MarkerSize',20,'LineWidth',2);
    h = text(C(GoalDestinations(i),2)+7,C(GoalDestinations(i),1),sprintf('%d',GoalDestinations(i)));
    set(h,'FontSize',24);
    set(h,'Color',[1 0 0]);
end

plot(C(s,2),C(s,1),'vm','MarkerSize',20,'LineWidth',2);
h = text(C(s,2)+7,C(s,1),sprintf('%d',s));
set(h,'FontSize',24);
set(h,'Color',[1 0 0]);

% draw edges next
for i = 1:nvertices
    to = find(A(i,:)>0);
    nneig = numel(to);
    for j = 1:nneig
        n = to(j);
        h = line([C(i,2) C(n,2)],[C(i,1) C(n,1)]);
        set(h,'LineWidth',2');
    end
end

end


