function [A,C] = LoadAndSemplifyGraph(AdjFileName,CoordsFileName,eliminateCloseby,threshold)

if nargin < 3
    eliminateCloseby = 0;
end

Adj = load(AdjFileName);
Coords = load(CoordsFileName);

fprintf('Number of vertices: %d\n',size(Adj,1));
outdegree = sum(Adj,2);
toEliminate = numel(find(outdegree==2));
fprintf('Number of vertices to eliminate: %d\n',toEliminate);


disp('Eliminating suprfluous vertices...');
while toEliminate > 0
    
    toGo = find(outdegree==2);
    toGo = toGo(1);  % vertex to eliminate
    connected = find(Adj(toGo,:)>0);
    from = connected(1);
    to = connected(2);
    Adj(from,to) = 1;
    Adj(to,from) = 1;
    Adj(toGo,:) = [];
    Adj(:,toGo) = [];
    Coords(toGo,:) = [];
    outdegree = sum(Adj,2);
    toEliminate = numel(find(outdegree==2));
end
disp('...done.');



if eliminateCloseby % further semplification
    disp('Peforming further semplification...');
    eliminated = 1;
    while eliminated > 0
        eliminated = 0;
        for i = 1:size(Adj,1)
            
            neighbors = find(Adj(i,:)>0);
            distances = zeros(1,numel(neighbors));
            for j = 1:numel(neighbors)
                distances(j) = hypot(Coords(i,2)-Coords(neighbors(j),2),Coords(i,1)-Coords(neighbors(j),1));
            end
            if min(distances) < threshold % found a vertex to eliminate?
                
                toGo = neighbors(distances<threshold); % this must go
                
                
                toGo = toGo(1);
                toStay = i;
                
                Adj(toStay,:) = Adj(toStay,:) + Adj(toGo,:);
                Adj(toStay,toStay) = 0; % eliminate self loop
                row = Adj(toStay,:);
                row(row>0) = 1;
                Adj(toStay,:) = row;
                Adj(:,toStay) = Adj(toStay,:);
                Adj(toGo,:) = [];
                Adj(:,toGo) = [];
                Coords(toGo,:) = [];
                eliminated = 1;
                break % star a new for cycle
                
                %                 outdegree = sum(Adj,2);
                %                 outCandidate = outdegree(toGo);
                %                 outOthers = outdegree(neighbors);
                %                 if outCandidate == min(outOthers)
                %                     for n1 = 1:numel(neighbors)
                %                         for n2 = 1:numel(neighbors)
                %                             if (n1 ~= n2)
                %                                 Adj(neighbors(n1),neighbors(n2)) = 1;
                %                                 Adj(neighbors(n2),neighbors(n1)) = 1;
                %                             end
                %                         end
                %                     end
                %
                %                 end
            end
        end
    end
    
    disp('...done.');
end

outdegree = sum(Adj,2);
toEliminate = numel(find(outdegree==2));

while toEliminate > 0
    
    toGo = find(outdegree==2);
    toGo = toGo(1);  % vertex to eliminate
    connected = find(Adj(toGo,:)>0);
    from = connected(1);
    to = connected(2);
    Adj(from,to) = 1;
    Adj(to,from) = 1;
    Adj(toGo,:) = [];
    Adj(:,toGo) = [];
    Coords(toGo,:) = [];
    outdegree = sum(Adj,2);
    toEliminate = numel(find(outdegree==2));
end


% DisplayGraphOnMap(Adj,Coords,[],1,'Maps/sdr40_final_inverted.bmp',1);
% keyboard
% close


A = Adj;
C = Coords;