function [ChosenDestinations,Successful,Reached]=RunMission(s,A,Params,Lookup,GoalDestinations)

% this function simulates a run with K robots and a given T
% s: source (deployment) vertex
% A: adjacency matrix for the graph

global K;
global DebugInfo;



ChosenDestinations = zeros(1,K);
Successful = zeros(1,K);
Reached = zeros(1,numel(GoalDestinations));
Selected = zeros(1,numel(GoalDestinations));
Solutions = cell(1,K);

for i = 1:K % for every robot
    
    if DebugInfo == 1
        fprintf('Planning for robot %d...\n',i);
    end
    ChosenDestinations(i) = PickRandomDestination(s,GoalDestinations);
    
    Selected(GoalDestinations==ChosenDestinations(i)) = 1;
    if DebugInfo == 1
        fprintf('Robot %d is going to vertex %d\n',i,ChosenDestinations(i));
    end
    Solutions{i} = SolvePointToPoint(s,ChosenDestinations(i),A,Params,Lookup);
    lastVertex = SimulateDeployment(s,ChosenDestinations(i),Solutions{i},Params,Lookup);
    if lastVertex == ChosenDestinations(i);
        if DebugInfo == 1
            fprintf('Robot %d reached its destination\n',i);
        end
        Successful(i) = 1;
        Reached(GoalDestinations==ChosenDestinations(i)) = 1;
    else
        if DebugInfo == 1
            fprintf('Robot %d did not reach its destination\n',i);
        end
    end
    
end

if DebugInfo == 1
    if sum(Reached) < size(A,1)-1
        
        fprintf('Robot team dit not successfully complete deployment mission.\n');
        fprintf('The following vertices were not reached\n');
        
        find(Reached==0)
        
        fprintf('The following vertices were not selected\n');
        
        find(Selected==0)
    else
        
        fprintf('Robot team  successfully completed deployment mission\n.')
        
    end
end