function f = SigmoidTransitionProbability(t,TMin,TMax)

% returns a sigmoid that is 0 for t < TMin and approaches 1 for T~TMax

%Alternatively one can try the Gompertz function



if t < TMin
    f = 0;
elseif t > TMax
    f = 1;
else
    x = 12*(t-TMin)/(TMax-TMin) - 6;
    f = 1/(1+exp(-x));
end


