function f = SolvePointToPointSimplified(s,d)

global T % global temporal deadline

global distance % distance from source (number of hops)
global parent % parent in path from source to destination

% solves the point-to-point problem from (s)ource to (d)estination under
% the assumption all S functions are equal. Must have preliminarily called
% Dijkstra

h = distance(d); % number of hops/edges from s to d
t = T/h; % time allocated on every edge of the path



destination = d;
source = parent(destination);
pos = h;
while destination ~= s
    edge = struct('source',source,'destination',destination,'t',t);
    f(pos) = edge;
    destination = source;
    source = parent(destination);
    pos = pos-1;
end
    


