% small code snippet to verify whether ComputeHittingTimes and
% ComputePfromH work (one should invert the other).

clc
close all
clear all

global epsilon;
epsilon = 10^-6;

%n = 5;

% P = rand(n,n);
% 
% for k = 1:n  % set n entries to 0
%     i = ceil(rand*n);
%     j = ceil(rand*n);
%     P(i,j) = 0;
%     P(j,i) = 0;
% end
% 
% P = [ 0 1 1 0 ;
%       1 0 0 1 ; 
%       1 0 0 1 ;
%       0 1 1 0 ];
%   
% P = P.*rand(size(P));  
% 
% for i = 1:size(P,1)
%     P(i,:) = P(i,:)/sum(P(i,:));
% end
% 
% P
% 
% H = ComputeHittingTimes(P)
% 
% Adj = P;
% Adj(Adj>0)= 1;
% 
% 
% [recovered,valid] = ComputePfromH(H,Adj);
% 
% if valid
%     recovered
% else
%     disp('Unfeasible H matrix');
% end



%adjacency matrix of the graph to be explored; MUST be symmetric

A = [ 0 1 1 0 ;
      1 0 0 1 ; 
      1 0 0 1 ;
      0 1 1 0 ];
  
if A ~= A'
    error('Adjacency matrix must be symmetric');
end

% start setting arbitrary probabilities

P = rand(size(A)).*A;
tot = sum(P,2);
for i = 1:size(P,1)
    P(i,:) = P(i,:)/tot(i);
end

figure


% try with fmincon
n = round(sqrt(numel(P)));

P0 = reshape(P,numel(P),1); % initial point
lb = zeros(size(P0));
ub = ones(size(P0));

% setup normalization constraints
Aeq = zeros(n,numel(P0));
beq = ones(n,1);


for i = 1:n
    Aeq(i,n*(i-1)+1:n*(i-1)+4) = ones(1,n);
end

% now set to 0 some probabilities....
AP = zeros(size(P));
Lin = zeros(numel(P),2);

K=1;
for i = 1:n
    for j = 1:n
        AP(i,j) = K;
        Lin(K,1) = i;
        Lin(K,2) = j;
        K = K+1;
    end
end

for i = 1:n
    for j = 1:n
        if A(i,j) == 0
            eq = AP(i,j);
            beq(end+1) = 0;
            Aeq(end+1,:) = 0;
            Aeq(end,eq) = 1;
        end
    end
end


options = optimset('Algorithm','sqp');

[Popt,fval,exitflag] = fmincon(@ObjectiveFunction,P0,[],[],Aeq,beq,lb,ub,[],options);

fval
exitflag

ObjectiveFunction(Popt)



Popt = reshape(Popt,4,4);
Popt = Popt'
ComputeHittingTimes(Popt)

return

converged = 0;
Hseries = zeros(0,1);
while converged == 0

    H = ComputeHittingTimes(P)

    highestH = max(max(H))
    if numel(Hseries) == 0
        Hseries = highestH;
    else
    Hseries(end+1) = highestH;
    end
    plot(Hseries)
    pause(0.2)
    
    targetH = H;
    targetH(abs(H-highestH)<epsilon) = highestH-0.1

    pos = find(H==highestH);
    H(pos(1)) = 0.99*H(pos(1));
    %H = 0.99*H;
    [P,valid] = ComputePfromH(targetH,A);
    disp('Computed P...');
    P
    valid
    disp('Corrected P...');
    for i = 1:size(P,1)
        P(i,:) = P(i,:)/sum(P(i,:));
    end
    P
    
   % pause

end

% LowerBounds = zeros(size(A));
% for i = 1:size(A,1)
%     distances = Dijkstra(A,i);
%     LowerBounds(i,:) = distances;
% end
% 
% LowerBounds
% 
% 
% 
% UpperBounds = 100 * LowerBounds; % this needs to be better estimated
% 
% converged = 0;
% 
% CurrentH =  LowerBounds;

% 
% while ~ converged
%    
%     [P,valid] = ComputePfromH(CurrentH,A);
%     if ~ valid
%         disp('Current H is unfeasible.... refining');
%         H
%         CurrentH = 2*CurrentH;
%         pause
%     else
%         disp('Found a feasible H');
%         P
%         CurrentH
%         pause
%     end
%         
% end


